'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LayoutMediaQueryFactory = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _resizeObserverPolyfill = require('resize-observer-polyfill');

var _resizeObserverPolyfill2 = _interopRequireDefault(_resizeObserverPolyfill);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _helpers = require('./helpers');

var _breakpoints = require('./breakpoints');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LayoutMediaQueryFactory = function LayoutMediaQueryFactory(BREAKPOINTS) {
  return function (_Component) {
    (0, _inherits3.default)(_class2, _Component);

    function _class2() {
      var _ref;

      var _temp, _this, _ret;

      (0, _classCallCheck3.default)(this, _class2);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = _class2.__proto__ || (0, _getPrototypeOf2.default)(_class2)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
        params: {}
      }, _this.containerResizeObserver = null, _this.matchQueries = (0, _helpers.matchQueries)(BREAKPOINTS), _this.handleWindowResize = function (e) {
        var width = e.target.outerWidth;
        var params = _this.state.params;

        var result = _this.matchQueries(width);
        if (!(0, _shallowequal2.default)(result, params)) _this.setState({ params: result });
      }, _this.handleContainerResize = function (entries) {
        var target = entries[0].target;
        var width = (0, _helpers.getWidth)(target);
        var params = _this.state.params;

        var result = _this.matchQueries(width);
        if (!(0, _shallowequal2.default)(result, params)) _this.setState({ params: result });
      }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(_class2, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var viewport = this.props.viewport; // eslint-disable-line react/prop-types

        var container = _reactDom2.default.findDOMNode(this);
        var initialWidth = 0;

        if (viewport) {
          window.addEventListener('resize', this.handleWindowResize);
          initialWidth = window.outerWidth;
        } else {
          this.containerResizeObserver = new _resizeObserverPolyfill2.default(this.handleContainerResize);
          this.containerResizeObserver.observe(container);
          initialWidth = (0, _helpers.getWidth)(container);
        }

        var result = this.matchQueries(initialWidth);
        this.setState({ params: result });
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.containerResizeObserver.disconnect();
        this.containerResizeObserver = null;
        window.removeEventListener('resize', this.handleResize);
      }
    }, {
      key: 'render',
      value: function render() {
        return this.props.children(this.state.params); // eslint-disable-line react/prop-types
      }
    }]);
    return _class2;
  }(_react.Component);
};

var LayoutMediaQuery = LayoutMediaQueryFactory(_breakpoints.BREAKPOINTS);
LayoutMediaQuery.displayName = 'LayoutMediaQuery';

LayoutMediaQuery.propTypes = {
  /** Wether to listen to the viewport resize or not (it listens to the container resize by default) */
  viewport: _propTypes2.default.bool
};

exports.default = LayoutMediaQuery;
exports.LayoutMediaQueryFactory = LayoutMediaQueryFactory;